#ifndef __CONSTANTS__
  #define __CONSTANTS__
  
  // ADXL345 Adress
  #define _DEV_ADDR      0x1D      // accel click - 0x53, on-obard accel - 0x1D

  // ADXL345 Register Definition
  #define _ACCEL_ERROR    0x02
  #define _POWER_CTL      0x2D
  #define _DATA_FORMAT    0x31
  #define _BW_RATE        0x2C
  #define _DATAX0         0x32
  #define _DATAX1         0x33
  #define _DATAY0         0x34
  #define _DATAY1         0x35
  #define _DATAZ0         0x36
  #define _DATAZ1         0x37
  #define _FIFO_CTL       0x38
  #define _INT_MAP        0x2F          // interrupt mapping
  #define _INT_ENABLE     0x2E          // interrupt enabling
  #define _INT_SOURCE     0x30          // interrupt monitoring (not used here)

  // various constants
  #define NUMBYT          6
  #define NUMSAM          25
  #define NUMTAP          4
  #define NUMAXIS         3
  #define SAMPERIOD       20            // sampling period [ms]
  #define WINMIN          15
  #define WINMAX          100
  #define MINWALKVPP      10000
  #define CL_BG           0x0000        // old - 0x39E7
  #define CL_LIGHT        0xEF7D
  #define CL_CUSTOMRED    0xAAAA
  #define CL_DIRTYELLOW   0xEECD
  #define CALIBSAM        50
  #define CALIBTIME       10
  #define CALIBMAX        20
  #define ADCTHRESHOLD    1500
  #define SCRWIDTH        240
  #define SCRHEIGHT       320
  #define THPER          (0.25)
  #define STILLVPPMULT    3
  
#endif