#include "datatypes.h"

#ifndef __DSP__
  #define __DSP__

  // moving average
  void MovAvX(int32_t*, int32_t*, uint8_t);
  // median filter
  void MedianFilter(int32_t*, int32_t*);

  // averaging
  int32_t AverX(int32_t*, uint8_t, uint8_t);
  // middle of three
  int32_t middleOfThree(int32_t, int32_t, int32_t);

  // finding dynamic threshold
  void FindParam(int32_t*, int32_t*, int32_t*, int32_t*);

  // exchanging
  void Exchange(int32_t*, int32_t*);

  //crossing the threshold
  inline bool_t NegativeCrossing(int32_t, int32_t, int32_t);
  inline bool_t PositiveCrossing(int32_t, int32_t, int32_t);

  // steps evaluation
  inline bool_t sameCross(bool_t, bool_t, bool_t);

  // condition for valid step
  bool_t ValidStepCond();

  // finding "steps"
  void FindStep(int32_t*, uint8_t, int32_t noiseThr, int32_t dynThr);

  // logical XOR
  inline bool_t Xor_t(bool_t, bool_t);

  // saves the type of current crossing for future comparisons
  inline bool_t SaveCross(int32_t sample, int32_t thr);

  // abs()
  int32_t abs_t(int32_t);

  // find min & max of an array
  //void FindExtr();
  void FindExtr(int32_t*, int32_t, int32_t*, int32_t*);

  // bubble sort
  void BubbleSort_t(int32_t*, int32_t);
  
#endif