#include "accel_header.h"
#include "datatypes.h"
#include "events.h"
#include "timers.h"
#include "accel_driver.h"

/**************************************************************************************************
* Function ToggleApp()
* -------------------------------------------------------------------------------------------------
* Overview: Event function starts/stops the pedometer
* Input: nothing
* Output: nothing
**************************************************************************************************/
void ToggleApp()
{
  if ((startPedometer == 0) && (wtSec > bncVal))
  {
    // draw the stop button
    DrawImage(stopFig);
    
    // restart the timer
    StopTimer4(); InitTimer4();
    
    // start the accelerometer
    ADXL345_Write(_POWER_CTL, 0x08);  // measurement mode ON


    
    currThr = STILLVPPMULT*stillVpp;
    prethVpp = (1/THPER)*currThr;
    
  //firstCalib = 1;
    initStep = 1;
    StartSeq();
    wtSec = secBuffer; // bring back the old value
    bncVal = wtSec; // prevent bounce
    startPedometer = 1;
  }
  else if ((startPedometer == 1) && (wtSec > bncVal))
  {
    // draw the start button
    DrawImage(startFig);

    // stop the accelerometer
    ADXL345_Write(_POWER_CTL, 0x00);
    
    bncVal = wtSec; // prevent bounce

    secBuffer = wtSec; // save current value
    
    EraseLabel(idleFig,CL_BG); EraseLabel(thrBigFig,CL_BG);
    timerTick = 0;
    
    startPedometer = 0;
  }
}
void Check_TP()
{
  if (TP_TFT_Press_Detect())
  {
    if (TP_TFT_Get_Coordinates(&xCrd, &yCrd) == 0)
    {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
    Process_TP_Press(xCrd, yCrd);
    }
  }
}
/*************************************************************************************************/
void Process_TP_Press(uint16_t X, uint16_t Y)
{
  exec_image = 0;
  Get_Object(X, Y);
  if (exec_image != 0) exec_image->OnPressPtr();
  return;
}
/*************************************************************************************************/
void Get_Object(uint16_t X, uint16_t Y)
{
  local_image = startFig;
  if (IsInsideObject(X, Y, local_image->Left, local_image->Top, local_image->Width, local_image->Height) == 1)
  {
    exec_image = local_image;
  }
}
/*************************************************************************************************/
static uint8_t IsInsideObject (uint16_t X, uint16_t Y, uint16_t Left, uint16_t Top, uint16_t Width, uint16_t Height)
{
        if ( (Left<= X) && (Left+ Width - 1 >= X) &&
             (Top <= Y) && (Top + Height - 1 >= Y) )
                return 1;
        else
        return 0;
}