#include "constants.h"

/**************************************************************************************************
* Function SDCARD_Start()
* -------------------------------------------------------------------------------------------------
* Overview: Function Initialize SPI bus connected to the card holder
* Input: Nothing
* Output: test status: 0 - skiped; 1 - success; 2 - failure to initialize
**************************************************************************************************/

// global variables

int check;
// Current date and time of testing
unsigned int year = 2014;
unsigned short month = 7;
unsigned short day = 25;
unsigned short hours = 12;
unsigned short minutes = 2;
unsigned short seconds = 15;
extern char filename[];

void SDCARD_Start(char *test) {

    // Reset the error flag
    *test = 0;
  
    // Initialize SPI communication(low speed)
    SPI3_Init_Advanced(_SPI_FPCLK_DIV64,
                       _SPI_MASTER | _SPI_8_BIT |
                       _SPI_CLK_IDLE_LOW | _SPI_FIRST_CLK_EDGE_TRANSITION |
                       _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1,
                       &_GPIO_MODULE_SPI3_PC10_11_12);

    Delay_ms(500);

    //--- init the FAT library
    check = Mmc_Fat_Init();

    if (!check)
    {
      *test = 1;
      
      // reinitialize spi at higher speed
      SPI3_Init_Advanced(_SPI_FPCLK_DIV2, _SPI_MASTER | _SPI_8_BIT |
                         _SPI_CLK_IDLE_LOW | _SPI_FIRST_CLK_EDGE_TRANSITION |
                         _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1,
                         &_GPIO_MODULE_SPI3_PC10_11_12);
      
      // format the sd card
      Mmc_Fat_QuickFormat("ACC_READ");
      Mmc_Fat_Set_File_Date(year,month,day,hours,minutes,seconds);   // Set file date & time info
      Mmc_Fat_Assign(&filename,0xA0);
      Mmc_Fat_Rewrite();                                             // To clear file and start with new data
    }
    else
    {
      *test = 2;
    }
}